package bank3tier.db; //DbJungeKundenQuery

//2005-04-07  Knabe  Erstellt

import bank3tier.db.Pool.ArgumentCountExc;
import bank3tier.db.Pool.ArgumentTypeExc;

import java.sql.Date;
import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.Query;

import org.hibernate.classic.Session;
import org.hibernate.criterion.Restrictions;


/**Liefert alle Zeilen der angesprochenen Tabelle, mit der Spalte 'geburt' ab i_args[0]
 * @throws ArgumentCountExc i_args nicht 1 Argument hat
 * @throws ArgumentTypeExc  i_args[0] nicht vom Typ java.sql.Date 
 */
public final class DbJungeKundenQuery extends HibernateQuery {

    @Override
    <T> List<T> execute(
            final _HibernatePool io_hibernatePool,
            final Class<T> i_resultClass, 
            final Object[] i_args
    ) throws ArgumentCountExc, ArgumentTypeExc
    {
        final int providedCount = i_args.length;
        final int neededCount = 1;
        if(providedCount!=neededCount){
            throw new ArgumentCountExc(getClass(), providedCount, neededCount);
        }
        final int argumentIndex = 0;
        final Object arg0 = i_args[argumentIndex];
        if(!(arg0 instanceof Date)){
            throw new ArgumentTypeExc(getClass(), argumentIndex, arg0.getClass(), Date.class);
        }
        final Date geburtsdatumAbDate = (Date)arg0;
		//return io_table.select("WHERE geburt >= '" + geburtsdatumAbDate + "'");
        final EntityManager session = io_hibernatePool.getEntityManager();
        /*final List<T> results = session.createCriteria(i_resultClass)
        .add( Restrictions.ge("geburt", geburtsdatumAbDate) )
        .list();*/
        final Query jpaQuery = session.createQuery(
            "select o from " + i_resultClass.getName() + " o WHERE geburt >= :geburt"
        );
        jpaQuery.setParameter("geburt", geburtsdatumAbDate);
        final List<T> results = jpaQuery.getResultList();
        return results;
	}

}
