/*
 * LgKontozugriff.java
 *
 * Created on 2. M�rz 2001, 13:19
 */

package bank3tier.lg;
import java.io.Serializable;

import javax.persistence.Entity;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

import  bank3tier.db.DbObject;

/**Assoziation "Kunde darf auf Konto zugreifen" mit spezifischen Rechten.
 * @author  Christoph Knabe
 */
@Entity @Table(name="Kontozugriff")
public class LgKontozugriff extends DbObject implements Serializable {
    

    private static final long serialVersionUID = 1441143823806974295L;

    /**Ob der Kunde Inhaber des Kontos ist (Gegenteil: nur Verwalter)*/
    private boolean inhaber;
    public static final String inhaberFIELD = "inhaber";
    
    @ManyToOne
    private LgKunde kunde;
    
    @ManyToOne
    private LgKonto konto;
    
    /**Gibt an, ob der verwaltende Kunde Inhaber des Kontos ist (true) oder nur verfügungsberechtigt (false).*/
    public boolean isInhaber(){return this.inhaber;}

    public LgKunde getKunde() {return this.kunde;}
    
    public LgKonto getKonto(){return this.konto;}
    
    @Override
    public String toString(){
        return getClass().getSimpleName() + " {oid=" + getOid() + ", isInhaber:" + this.inhaber + ", kunde: " + this.kunde + ", konto: " + this.konto + '}';
    }
    
    /** Creates unstored new link object*/
    LgKontozugriff(final LgKunde i_kunde, boolean isInhaber, final LgKonto i_konto){
        this.kunde = i_kunde;
        this.inhaber = isInhaber;
        this.konto = i_konto;
    }
        
    /*package*/ LgKontozugriff(){/*necessary for Hibernate*/}
    
    //We try to implement business key equality for this class:
    
    @Override
    public boolean equals(final Object other) {
        if (this == other) return true;
        if ( !(other instanceof LgKontozugriff) ) return false;
        final LgKontozugriff otherLgKontozugriff = (LgKontozugriff) other;
        System.out.println(getClass().getSimpleName() + ".equals(...) called");
        return this.getKunde().equals(otherLgKontozugriff.getKunde())
            && this.getKonto().equals(otherLgKontozugriff.getKunde())
        ;
    }

    @Override
    public int hashCode() {
        System.out.println(getClass().getSimpleName() + ".hashCode() called");
        final int result = this.getKunde().hashCode() * 29 + this.getKonto().hashCode();
        return result;
    }
      

}